#ifndef _SMBC_PRC_COMMON_H_
#define _SMBC_PRC_COMMON_H_


#define SMBC_PRC_SOCK_PATH          "/udom/"
#define SMBC_PRC_SOCK_SID_NAME      "SMBC_PROCESS_SID"


#define SMB_MAX_BUF_SIZE 65535
#define SMB_MIN_BUF_SIZE 6

#define SMB_PARAM_TAG_LEN        1
#define SMB_PARAM_LENGTH_LEN     2
#define SMB_MSG_MSG_ID_LEN       1
#define SMB_MSG_DF_START_POS     3
#define SMB_MSG_TOTALLEN_LEN     2

#define SMBC_CONNECT_ERR         -1
#define SMBC_CONNECT_ABORT_ERR   -2
#define SMBC_PARAM_SET_ERR       -3
#define SMBC_PARAM_SERCH_ERR     -4
#define SMBC_MSG_SND_ERR         -5
#define SMBC_MSG_SND_ABORT_ERR   -6
#define SMBC_MSG_RCV_ERR          0
#define SMBC_MSG_RCV_ABORT_ERR    1

#define SMBC_MAX_CHLD_NUM         10
#define SMBC_PARAM_AN_SUCCESS      0
#define SMBC_PARAM_AN_ERR         -1

#ifndef MIN
#define MIN(a,b) ((a)<(b)?(a):(b))
#endif



#define SMBC_MSG_OPEN            1
#define SMBC_MSG_CLOSE           2
#define SMBC_MSG_CONNECT         3
#define SMBC_MSG_DISCONNECT      4
#define SMBC_MSG_OPNFILE         5
#define SMBC_MSG_CLSFILE         6
#define SMBC_MSG_READFILE        7
#define SMBC_MSG_WRTFILE         8
#define SMBC_MSG_DELFILE         9
#define SMBC_MSG_MKDIR           10
#define SMBC_MSG_DELDIR          11
#define SMBC_MSG_CHKDIR          12
#define SMBC_MSG_GET_GRPL        13
#define SMBC_MSG_GET_SRVL        14
#define SMBC_MSG_GET_SHRL        15
#define SMBC_MSG_GET_DIRL        16
#define SMBC_MSG_GET_SRVCAP      17
#define SMBC_MSG_USR_LIN         18
#define SMBC_MSG_USR_LOUT        19
#define SMBC_MSG_GET_DCINF       20
#define SMBC_MSG_USR_GETGRP      21
#define SMBC_MSG_SET_DF_CHRC     22

#define SMB_MSG_ID               99


/////// COMMON
#define SMB_PARAM_MSG_TYPE       30
#define SMB_PARAM_R_CODE         31
#define SMB_PARAM_CHAR_ID        32
#define SMB_PARAM_MAX_LST_N      33
#define SMB_PARAM_FID            34
#define SMB_PARAM_ENT            35
#define SMB_PARAM_TOTAL          36

/////// Connect
//smb_vc
#define SMB_PARAM_GRP_NAME       37
#define SMB_PARAM_SRV_NAME       38
#define SMB_PARAM_SHRE           39
#define SMB_PARAM_USER_NAME      40
#define SMB_PARAM_PASS_WORD      41

/////// OpenFile
//smb_file
#define SMB_PARAM_F_NAME         42
#define SMB_PARAM_F_ACC          43
#define SMB_PARAM_F_ATTR         44
#define SMB_PARAM_F_DISPOS       45
#define SMB_PARAM_F_FLAG         46

//smb_finfo
#define SMB_PARAM_FI_CRE_TM      47
#define SMB_PARAM_FI_ACC_TM      48
#define SMB_PARAM_FI_WRT_TM      49
#define SMB_PARAM_FI_CHG_TM      50
#define SMB_PARAM_FI_ATTR        51
#define SMB_PARAM_FI_SIZE        52

/////// ReadFile
#define SMB_PARAM_OFFSET         53
#define SMB_PARAM_BUF            54
#define SMB_PARAM_SIZE           55

/////// WriteFile
#define SMB_PARAM_MODE           56

/////// GetGroupList
#define SMB_PARAM_GL_GP_NAME     57
#define SMB_PARAM_GL_GP_V_MJ     58
#define SMB_PARAM_GL_GP_V_MN     59
#define SMB_PARAM_GL_GP_TYPE     60
#define SMB_PARAM_GL_GP_MSTBR    61

/////// GetServerList
#define SMB_PARAM_SVI_SV_NAME    62
#define SMB_PARAM_SVI_SV_V_MJ    63
#define SMB_PARAM_SVI_SV_V_MN    64
#define SMB_PARAM_SVI_SV_TYPE    65
#define SMB_PARAM_SVI_SV_COMM    66

/////// GetShareList
#define SMB_PARAM_SHI_SH_NAME    67
#define SMB_PARAM_SHI_SH_COMM    68

/////// DirectoryList
#define SMB_PARAM_DIR            69
#define SMB_PARAM_DLI_DR_NAME    70

/////// GetServerCapability
#define SMB_PARAM_CP_FLAG        71
#define SMB_PARAM_CP_SEC_MD      72
#define SMB_PARAM_CP_ENCKY_L     73
#define SMB_PARAM_CP_ENCKY       74

/////// GetDCInfo
#define SMB_PARAM_DC_ADDR        75

/////// UserGetGroups
#define SMB_PARAM_UGI_UGP_NAME   76

/////// SetDefaultCharCode
#define SMB_PARAM_DEF_CHR_CODE   77




#endif  /* _SMBC_PRC_COMMON_H_ */
