#ifndef _SMBC_PRC_LOCAL_H_
#define _SMBC_PRC_LOCAL_H_


#include <smbc_prc_common.h>
#include <smbc_lib.h>


typedef struct wk_smb_msg {
        u_short  type;
        int     (*func)();
} wk_smb_msg_t;



void NcsSmbPrcHandler(int sockfd ,int chld_cnt);
int smbc_param_an_OPEN(const u_char* smbc_rv_buf ,u_char* smbc_sn_buf ,smb_ctx** ctx);
int smbc_param_an_CLOSE(const u_char* smbc_rv_buf ,u_char* smbc_sn_buf ,smb_ctx* ctx);
int smbc_param_an_CONNECT(const u_char* smbc_rv_buf ,u_char* smbc_sn_buf ,smb_ctx* ctx);
int smbc_param_an_DISCONNECT(const u_char* smbc_rv_buf ,u_char* smbc_sn_buf ,smb_ctx* ctx);
int smbc_param_an_OPNFILE(const u_char* smbc_rv_buf ,u_char* smbc_sn_buf ,smb_ctx* ctx);
int smbc_param_an_CLSFILE(const u_char* smbc_rv_buf ,u_char* smbc_sn_buf ,smb_ctx* ctx);
int smbc_param_an_READFILE(const u_char* smbc_rv_buf ,u_char* smbc_sn_buf ,smb_ctx* ctx ,
                           int smbc_srv_fd , u_char* check_msg_ID);
int smbc_param_an_WRTFILE(u_char* smbc_rv_buf ,u_char* smbc_sn_buf, smb_ctx* ctx ,
                          int smbc_srv_fd , u_char* check_msg_ID);
int smbc_param_an_DELFILE(const u_char* smbc_rv_buf ,u_char* smbc_sn_buf ,smb_ctx* ctx);
int smbc_param_an_MKDIR(const u_char* smbc_rv_buf ,u_char* smbc_sn_buf ,smb_ctx* ctx);
int smbc_param_an_DELDIR(const u_char* smbc_rv_buf ,u_char* smbc_sn_buf ,smb_ctx* ctx);
int smbc_param_an_CHKDIR(const u_char* smbc_rv_buf ,u_char* smbc_sn_buf ,smb_ctx* ctx);
int smbc_param_an_GET_GRPL(const u_char* smbc_rv_buf ,u_char* smbc_sn_buf ,smb_ctx* ctx);
int smbc_param_an_GET_SRVL(const u_char* smbc_rv_buf ,u_char* smbc_sn_buf ,smb_ctx* ctx);
int smbc_param_an_GET_SHRL(const u_char* smbc_rv_buf ,u_char* smbc_sn_buf ,smb_ctx* ctx);
int smbc_param_an_GET_DIRL(const u_char* smbc_rv_buf ,u_char* smbc_sn_buf ,smb_ctx* ctx);
int smbc_param_an_GET_SRVCAP(const u_char* smbc_rv_buf ,u_char* smbc_sn_buf ,smb_ctx* ctx);
int smbc_param_an_USR_LOGIN(const u_char* smbc_rv_buf ,u_char* smbc_sn_buf ,smb_ctx* ctx);
int smbc_param_an_USR_LOGOUT(const u_char* smbc_rv_buf ,u_char* smbc_sn_buf ,smb_ctx* ctx);
int smbc_param_an_GET_DCInf(const u_char* smbc_rv_buf ,u_char* smbc_sn_buf ,smb_ctx* ctx);
int smbc_param_an_USR_GET_Groups(const u_char* smbc_rv_buf ,u_char* smbc_sn_buf ,smb_ctx* ctx);
int smbc_param_an_DF_CHR_CODE(const u_char* smbc_rv_buf ,u_char* smbc_sn_buf ,smb_ctx* ctx);

int smbc_prc_get_param(int cnt , u_char srch_param , const u_char* smbc_rv_buf ,char* get_param);
int smbc_prc_set_param( u_char *smbc_sn_buf , u_char param_tag ,  u_short length , u_char *param_value , int in_offset );
int smbc_prc_recv_buf( u_char* smbc_rv_buf , int smbc_srv_fd);
int smbc_prc_send_buf( const u_char* smbc_sn_buf , u_short total_len , int smbc_srv_fd);
int smbc_prc_cnv_err(int class, int condition, int code);
void smbc_prc_sig_chld(int signo );
int smbc_prc_recv_min( int smbc_srv_fd , u_char* smbc_rv_buf , int recv_option);
u_short  smbc_prc_buf_ID_PEEK(char* smbc_rv_buf,u_char *check_msg_ID, int smbc_srv_fd );


#endif  /* _SMBC_PRC_LOCAL_H_ */




