/* -*- tab-width: 4; -*- */
/*------------------------------------------------------------------*
 * Filename:		libnbt_cm.h
 *------------------------------------------------------------------*/


#ifndef _LIBNBT_CM_H_
#define _LIBNBT_CM_H_

#ifdef __cplusplus
extern "C" {
#endif

extern int nbt_open(int serviceType, unsigned long srcnaddr, unsigned short srcnport);
extern int nbt_close(int s);
extern int nbt_getsockopt(int s, int level, int optname, void *optval, int *optlen);
extern int nbt_setsockopt(int s, int level, int optname, const void *optval, int optlen);
extern int nbt_getfd(int s);
extern int nbt_getnbtfd(int s);
extern int nbt_setnodetype(int nodetype);
extern int nbt_getnodetype(void);

extern int nbt_setbcaddr(int s, unsigned long bcnaddr);
extern int nbt_getbcaddr(int s);
extern int nbt_setwinsaddr(unsigned long naddr);
extern int nbt_getwinsaddr(void);
extern int nbt_setlocalwinsaddr(int s, unsigned long naddr);
extern int nbt_getlocalwinsaddr(int s);


extern int nbt_setscopeid(const char* scopeid);
extern const char* nbt_getscopeid(void);

extern int nbt_setlocalscopeid(int s, const char* scopeid);
extern const char* nbt_getlocalscopeid(int s);

extern void nbt_forcesettinginit(NBTForceSettingInfo* fcinfo);


#ifdef __cplusplus
}
#endif

#endif // _LIBNBT_CM_H_
