/* -*- tab-width: 4; -*- */
/*------------------------------------------------------------------*
 * Filename:		libnbt_mes.h
 *------------------------------------------------------------------*/

#ifndef _LIBNBT_MES_H_
#define _LIBNBT_MES_H_

#ifdef __cplusplus
extern "C" {
#endif


#define NBT_NS_MT_UNKNOWN			(-1)
#define NBT_NS_MT_REQ_NAMEREG		0
#define NBT_NS_MT_REQ_MHNAMEREG		1
#define NBT_NS_MT_REQ_NAMEOW		2
#define NBT_NS_MT_REQ_REF			3
#define NBT_NS_MT_REQ_REL			4
#define NBT_NS_MT_REQ_NAMEQUERY		5
#define NBT_NS_MT_REQ_NODESTATUS	6

#define NBT_NS_MT_RES_WACK			10
#define NBT_NS_MT_RES_POS_NAMEREG	11
#define NBT_NS_MT_RES_NEG_NAMEREG	12
#define NBT_NS_MT_RES_ENCREG		13
#define NBT_NS_MT_RES_POS_NAMEREL	14
#define NBT_NS_MT_RES_NEG_NAMEREL	15
#define NBT_NS_MT_RES_POS_NAMEQUERY	16
#define NBT_NS_MT_RES_NEG_NAMEQUERY	17
#define NBT_NS_MT_RES_REDNAMEQUERY	18
#define NBT_NS_MT_RES_NODESTATUS	19

#define NBT_NS_MT_RES_NAMECFTDEMAND	30


// OPCODE
#define VAL_OC_QUERY		0
#define VAL_OC_REGISTRATION	5
#define VAL_OC_RELEASE		6
#define VAL_OC_WACK			7
#define VAL_OC_REFRESH		8
#define VAL_OC_MULTIHOMED	15	// multihomed


// R
#define VAL_R_REQUEST		0
#define VAL_R_RESPONSE		1


// B
#define VAL_B_UNICAST	0
#define VAL_B_BROADCAST	1


// ONT
#define VAL_ONT_B	0x0	// B-node
#define VAL_ONT_P	0x1	// P-node
#define VAL_ONT_M	0x2	// M-node
#define VAL_ONT_H	0x3	// H-node

// G
#define VAL_G_UNIQUE	0	// unique NetBIOS name
#define VAL_G_GROUP		1	// group netBIOS name

// RCODE
#define VAL_RC_SUCCESS	0x0
#define VAL_RC_FMT_ERR	0x1
#define VAL_RC_SRV_ERR	0x2
#define VAL_RC_NAM_ERR	0x3
#define VAL_RC_IMP_ERR	0x4
#define VAL_RC_RFS_ERR	0x5
#define VAL_RC_ACT_ERR	0x6
#define VAL_RC_CFT_ERR	0x7


/*	bZ[W쐬֐ɓnp[^̊{`
	bZ[W͊֐ɂnƂB */
typedef struct tag_stNameServicePrimitiveRequest
{
	u_short	TranID;
	u_long	TTL;
	u_char	QName[NBT_LENGTH_NETBIOSNAME];
	u_char	QScopeId[NBT_LENGTH_SCOPEID];
	u_char	RRName[NBT_LENGTH_NETBIOSNAME];
	u_char	RScopeId[NBT_LENGTH_SCOPEID];
	u_long	NbAddress;
	u_char	ONT;
	u_char	Rcode;
	u_short	nmflags;
#define NS_NSPR_NMFLAGS_AA_ON	(1<<0)
#define NS_NSPR_NMFLAGS_TC_ON	(1<<1)
#define NS_NSPR_NMFLAGS_RD_ON	(1<<2)
#define NS_NSPR_NMFLAGS_RA_ON	(1<<3)
#define NS_NSPR_NMFLAGS_B_ON	(1<<4)

	u_char	G;

	u_char	flag;
#define NS_NSPR_FLAG_QSCOPEID_LACKED	(1<<0)	// QScopeID񂪌
#define NS_NSPR_FLAG_RSCOPEID_LACKED	(1<<1)	// RScopeID񂪌
#define NS_NSPR_FLAG_HFLAG_USED			(1<<2)	// hflagL


} stNameServicePrimitiveRequest;


typedef stNameServicePrimitiveRequest stNameRegistrationRequest;
typedef stNameServicePrimitiveRequest stNameOverwriteRequest;
typedef stNameServicePrimitiveRequest stNameRefreshRequest;
typedef stNameServicePrimitiveRequest stNameReleaseRequest;
typedef stNameServicePrimitiveRequest stNameQueryRequest;
typedef stNameServicePrimitiveRequest stNodeStatusRequest;

/* nmflagsbZ[W^CvƂ̃ftHgZbeBO */
#define DEF_NMFLAGS_REQ_NAMEREG			NS_NSPR_NMFLAGS_RD_ON
#define DEF_NMFLAGS_REQ_MHNAMEREG		NS_NSPR_NMFLAGS_RD_ON
#define DEF_NMFLAGS_REQ_NAMEOW			(0x0)
#define DEF_NMFLAGS_REQ_REF				(0x0)
#define DEF_NMFLAGS_REQ_REL				(0x0)
#define DEF_NMFLAGS_REQ_NAMEQUERY		NS_NSPR_NMFLAGS_RD_ON
#define DEF_NMFLAGS_REQ_NODESTATUS		NS_NSPR_NMFLAGS_AA_ON

#define DEF_NMFLAGS_RES_WACK			NS_NSPR_NMFLAGS_AA_ON
#define DEF_NMFLAGS_RES_POS_NAMEREG		(NS_NSPR_NMFLAGS_AA_ON|NS_NSPR_NMFLAGS_RD_ON|NS_NSPR_NMFLAGS_RA_ON)
#define DEF_NMFLAGS_RES_NEG_NAMEREG		(NS_NSPR_NMFLAGS_AA_ON|NS_NSPR_NMFLAGS_RD_ON|NS_NSPR_NMFLAGS_RA_ON)
#define DEF_NMFLAGS_RES_ENCREG			(NS_NSPR_NMFLAGS_AA_ON|NS_NSPR_NMFLAGS_RD_ON)
#define DEF_NMFLAGS_RES_POS_NAMEREL		NS_NSPR_NMFLAGS_AA_ON
#define DEF_NMFLAGS_RES_NEG_NAMEREL		NS_NSPR_NMFLAGS_AA_ON
#define DEF_NMFLAGS_RES_POS_NAMEQUERY	(NS_NSPR_NMFLAGS_AA_ON|NS_NSPR_NMFLAGS_RD_ON)
#define DEF_NMFLAGS_RES_NEG_NAMEQUERY	(NS_NSPR_NMFLAGS_AA_ON|NS_NSPR_NMFLAGS_RD_ON)
#define DEF_NMFLAGS_RES_REDNAMEQUERY	NS_NSPR_NMFLAGS_RD_ON
#define DEF_NMFLAGS_RES_NODESTATUS		NS_NSPR_NMFLAGS_AA_ON
#define DEF_NMFLAGS_RES_NAMECFTDEMAND	(NS_NSPR_NMFLAGS_AA_ON|NS_NSPR_NMFLAGS_RD_ON|NS_NSPR_NMFLAGS_RA_ON)



typedef struct tag_stRequestMessageInfo
{
	int		fd;				/* \PbgfBXNv^ */
	int		mestype;		/* M郁bZ[W^Cv */
	u_long	dstnaddr;		/* IPAhX */
	u_short	dstnport;		/* |[gԍ */
	int		retry;			/* đ */
	int		timeout;		/* ҂^CAEg */
	u_char	waitresponse;	/* M悩̉҂ */
	u_long	ignoreresponse;	/* 𖳎^Cvw */
#define NS_RESTYPE_POSITIVE			(1<<0)
#define NS_RESTYPE_NEGATIVE			(1<<1)
#define NS_RESTYPE_ENODECHA			(1<<2)
#define NS_RESTYPE_REDIRECT			(1<<3)

	stNameServicePrimitiveRequest prim;	/* vf[^ */
	int		retval;			/* bZ[W^Cv */
	void*	rinfo[5];		/* ̒l */
	int		interruptd;		/* fp\PbgfBXNv^ */
	
} stRequestMessageInfo;


// bZ[W͊֐ɓnp[^̊{`


typedef struct tag_stNameServicePrimitiveResponse
{
	u_char	rcode;		// error-code
	u_long	ttl;		// TimeToLive
	union{
		u_long	naddr;	// NetBIOS addr
		struct e{
			u_short nentries;
			u_short	nentries_read;
		} e;
	} u;

#define NSPR_naddr			u.naddr
#define NSPR_nentries		u.e.nentries
#define NSPR_nentries_read	u.e.nentries_read

} stNameServicePrimitiveResponse;

typedef stNameServicePrimitiveResponse stNameRegistrationResponse;
typedef stNameServicePrimitiveResponse stNameOverwriteResponse;
typedef stNameServicePrimitiveResponse stNameRefreshResponse;
typedef stNameServicePrimitiveResponse stNameReleaseResponse;
typedef stNameServicePrimitiveResponse stNameQueryResponseHeader;
typedef stNameServicePrimitiveResponse stNodeStatusResponseHeader;


typedef struct tag_stNameServiceAddrEntry
{
	u_long	nbaddr;
	u_char	G;
	u_char	ONT;
	
} stNameServiceAddrEntry;



typedef struct tag_stNameServiceNodeNameEntry
{
	u_char	nbname[NBT_LENGTH_NETBIOSNAME];
	u_char	G;
	u_char	ONT;
	u_char	state;
#define NS_NNE_STATE_DRG_ON	(1<<0)
#define NS_NNE_STATE_CNF_ON	(1<<1)
#define NS_NNE_STATE_ACT_ON	(1<<2)
#define NS_NNE_STATE_PRM_ON	(1<<3)

	
} stNameServiceNodeNameEntry;



#ifdef WIN32
#pragma pack(push, 1)
#endif // WIN32

struct tag_stNameServiceStatistics
{
	u_char	UNIT_ID[6]; // MAC ADDRESS
	u_char	JUMPERS;
	u_char	TEST_RESULT;
	u_short	VERSION_NUMBER;
	u_short	PERIOD_OF_STATISTICS;
	u_short	NUMBER_OF_CRCs;
	u_short	NUMBER_ALIGNMENT_ERRORS;
	u_short	NUMBER_OF_COLLISIONS;
	u_short	NUMBER_SEND_ABORTS;
	u_long	NUMBER_GOOD_SENDS;
	u_long	NUMBER_GOOD_RECEIVES;
	u_short	NUMBER_RETRANSMITS;
	u_short	NUMBER_NO_RESOURCE_CONDITIONS;
	u_short	NUMBER_FREE_COMMAND_BLOCKS;
	u_short	TOTAL_NUMBER_COMMAND_BLOCKS;
	u_short	MAX_TOTAL_NUMBER_COMMAND_BLOCKS;
	u_short	NUMBER_PENDING_SESSIONS;
	u_short	MAX_NUMBER_PENDING_SESSIONS;
	u_short	MAX_TOTAL_SESSIONS_POSSIBLE;
	u_short	SESSION_DATA_PACKET_SIZE;

#ifndef WIN32
} __attribute__((__packed__));
#else	
};
#endif // WIN32

#ifdef WIN32
#pragma pack(pop)
#endif // WIN32

typedef struct tag_stNameServiceStatistics stNameServiceStatistics;


typedef struct stNameServicePacketHeaderInfo_tag
{
	u_short	id;
	u_char	response;
	u_short	qdc;
	u_short	anc;
	u_short	nsc;
	u_short	arc;
	u_short	nmflags;
	u_char	rcode;
	u_char	oc;

} stNameServicePacketHeaderInfo;


typedef struct stNameServiceQuestionSectionInfo_tag
{
	u_short	qtype;
	u_short	qclass;
	u_char*	qname;	// qname16byteŒ

	u_char* qscopeid;
	int		qscopeid_len;

	u_char	uselabel;	// labelgp邩^gpĂ邩
	u_short	labelindex;	// label̃CfbNX
	u_char*	top;		// NBTbZ[W̐擪AhX

} stNameServiceQuestionSectionInfo;


typedef struct stNameServiceQuestionSectionInfo2_tag
{
	u_short	qtype;
	u_short	qclass;
	u_char	qname[NBT_LENGTH_NETBIOSNAME];
	u_char	qscopeid[NBT_LENGTH_SCOPEID];
	
	u_char	uselabel;	// labelgp邩^gpĂ邩
	u_short	labelindex;	// label̃CfbNX
	u_char*	top;		// NBTbZ[W̐擪AhX

} stNameServiceQuestionSectionInfo2;


typedef struct stNameServiceResourceRecodeInfo_tag
{
	stNameServiceQuestionSectionInfo s;

	u_long	ttl;
	u_short	rdatalen;
	u_char*	rdata;

} stNameServiceResourceRecodeInfo;


typedef struct stNameServiceResourceRecodeInfo2_tag
{
	stNameServiceQuestionSectionInfo2 s;

	u_long	ttl;
	u_short	rdatalen;
	u_char*	rdata;		// dataւ̃|C^

} stNameServiceResourceRecodeInfo2;



typedef struct tag_stNameServiceMessageInfo
{
	stNameServicePacketHeaderInfo		h;
	stNameServiceQuestionSectionInfo2*	qd;
	stNameServiceResourceRecodeInfo2*	an;
	stNameServiceResourceRecodeInfo2*	ns;
	stNameServiceResourceRecodeInfo2*	ar;

} stNameServiceMessageInfo;



//////////////// UserDatagram

// DatagramService֌W̊֐ł肷
typedef struct tag_stDatagramPrimitive
{
	u_char	msgtype;
	u_char	snt;

	u_char	more_flag;	// tOgꂽpPbg܂
	u_char	first_flag;	// itOgꂽpPbĝjŏ̃pPbg
	
	u_short	id;
	u_long	naddr;
	u_short	nport;
	
	union{
		struct form1{
			u_char	srcname[NBT_LENGTH_NETBIOSNAME];
			u_char	dstname[NBT_LENGTH_NETBIOSNAME];
			u_char	scopeid[NBT_LENGTH_SCOPEID];

			u_short	datalen;
			u_char*	data;
			u_short	offset;
			u_short	headerlen;	// srcname + scopeid + dstname + scopeid
		} form1;

		struct form2{
			u_char	ecode;
		} form2;

		struct form3{
			u_char	dstname[NBT_LENGTH_NETBIOSNAME];
			u_char	scopeid[NBT_LENGTH_SCOPEID];
		} form3;
	} u;
#define DP1_srcname		u.form1.srcname
#define DP1_dstname		u.form1.dstname
#define DP1_scopeid		u.form1.scopeid
#define DP1_datalen		u.form1.datalen
#define DP1_data		u.form1.data
#define DP1_offset		u.form1.offset
#define DP1_headerlen	u.form1.headerlen
#define DP2_ecode		u.form2.ecode
#define DP3_dstname		u.form3.dstname
#define DP3_scopeid		u.form3.scopeid


} stDatagramPrimitive;



#define VAL_DSF_MTYPE_DIRECT_UNIQUE_DATAGRAM					0x10
#define VAL_DSF_MTYPE_DIRECT_GROUP_DATAGRAM						0x11
#define VAL_DSF_MTYPE_BROADCAST_DATAGRAM						0x12
#define VAL_DSF_MTYPE_DATAGRAM_ERROR							0x13
#define VAL_DSF_MTYPE_DATAGRAM_QUERY_REQUEST					0x14
#define VAL_DSF_MTYPE_DATAGRAM_POSITIVE_QUERY_RESPONSE			0x15
#define VAL_DSF_MTYPE_DATAGRAM_NEGATIVE_QUERY_RESPONSE			0x16


// ERROR CODE
#define VAL_DSF_ECODE_DSTNAME_NOT_PRESENT		0x82
#define VAL_DSF_ECODE_INVALID_SRCNAME_FORMAT	0x83
#define VAL_DSF_ECODE_INVALID_DSTNAME_FORMAT	0x84


// ֐錾
extern int get_NameServiceMessage(stNameServiceMessageInfo* info, const u_char* in, int* retval);
extern int get_NameServiceMessageType(const char* in);

// --  create *Request
extern int create_NameRegistrationRequest(u_char* out, const stNameRegistrationRequest* data);
extern int create_MultihomedNameRegistrationRequest(u_char* out, const stNameRegistrationRequest* data);
extern int create_NameOverwriteRequest(u_char* out, const stNameOverwriteRequest* data);
extern int create_NameRefreshRequest(u_char* out, const stNameRefreshRequest* data);
extern int create_NameReleaseRequest(u_char* out, const stNameReleaseRequest* data);
extern int create_NameQueryRequest(u_char* out, const stNameQueryRequest* data);
extern int create_NodeStatusRequest(u_char* out, stNodeStatusRequest* data);

// -- create *Response
extern int create_PositiveNameRegistrationResponse(u_char* out, const stNameRegistrationRequest* data);
extern int create_NegativeNameRegistrationResponse(u_char* out, const stNameRegistrationRequest* data);
extern int create_EndNodeChallengeRegistrationResponse(u_char* out, const stNameRegistrationRequest* data);
extern int create_NameRegistrationResponse(u_char* out, int type, const stNameRegistrationRequest* data);
extern int create_PositiveNameReleaseResponse(u_char* out, const stNameReleaseRequest* data);
extern int create_NegativeNameReleaseResponse(u_char* out, const stNameReleaseRequest* data);
extern int create_NameReleaseResponse(u_char* out, int type, const stNameReleaseRequest* data);
extern int create_PositiveNameQueryResponse(u_char* out, const stNameQueryRequest* dh,
											const stNameServiceAddrEntry* dd, int num);
extern int create_NegativeNameQueryResponse(u_char* out, const stNameQueryRequest* dh);
extern int create_RedirectNameQueryResponse(u_char* out, const stNameQueryRequest* dh);
extern int create_NameQueryResponse(u_char* out, int type, const stNameQueryRequest* dh,
									const stNameServiceAddrEntry* dd, int num);
extern int create_NodeStatusResponse(u_char* out, const stNodeStatusRequest* dh,
									 const stNameServiceNodeNameEntry* dnn, int num, const stNameServiceStatistics* dns);

// -- get *Request
extern int get_xRequest(stNameServicePrimitiveRequest* data, stNameServiceMessageInfo* info, const u_char* in);
extern int get_NameRegistrationRequest(stNameRegistrationRequest* data, const u_char* in);
extern int get_NameOverwriteRequest(stNameOverwriteRequest* data, const u_char* in);
extern int get_NameRefreshRequest(stNameRefreshRequest* data, const u_char* in);
extern int get_NameReleaseRequest(stNameReleaseRequest* data, const u_char* in);
extern int get_NameQueryRequest(stNameQueryRequest* data, const u_char* in);
extern int get_NodeStatusRequest(stNodeStatusRequest* data, const u_char* in);

// -- get *Response
extern int get_WackResponse(stNameServicePrimitiveRequest* data, const u_char* in);
extern int get_PositiveNameRegistrationResponse(stNameServicePrimitiveRequest* data, const u_char* in);
extern int get_NegativeNameRegistrationResponse(stNameServicePrimitiveRequest* data, const u_char* in);
extern int get_EndNodeChallengeRegistrationResponse(stNameServicePrimitiveRequest* data, const u_char* in);
extern int get_PositiveNameReleaseResponse(stNameServicePrimitiveRequest* data, const u_char* in);
extern int get_NegativeNameReleaseResponse(stNameServicePrimitiveRequest* data, const u_char* in);
extern int get_PositiveNameQueryResponse(stNameServicePrimitiveRequest* data, stNameServiceAddrEntry* ent, int num,
								  int* findnum, const u_char* in);
extern int get_NegativeNameQueryResponse(stNameServicePrimitiveRequest* data, const u_char* in);
extern int get_RedirectNameQueryResponse(stNameServicePrimitiveRequest* data, const u_char* in);
extern int get_NodeStatusResponse(stNameServicePrimitiveRequest* data, stNameServiceNodeNameEntry* dnn, int num, int* readnum,
						   stNameServiceStatistics* dns, const u_char* in);
extern int set_tranID(u_char* out, u_short tid);
extern int send_RequestMessageRepeatAnyTimes(stRequestMessageInfo* info);

// datagram
extern int create_DatagramFormat(u_char* out, const stDatagramPrimitive* data);
extern int get_DatagramFormat(stDatagramPrimitive* data, const u_char* in);


//////////////////// session
// NBT Session format
// type		:	1byte
// flag		:	1byte
// length	:	2bytes
// trailer	:	any
//
// type: 00h	ZbVEbZ[W
// type: 81h	ZbVv
// type: 82h	ZbVimj
// type: 83h	ZbViےj
// type: 84h	ZbViύXj
// type: 85h	ZbVԊmFiKeep-Alivej

#define VAL_SESSION_MESSAGE				0x00
#define VAL_SESSION_REQUEST				0x81
#define VAL_SESSION_RESPONSE_ACK		0x82
#define VAL_SESSION_RESPONSE_NACK		0x83
#define VAL_SESSION_RESPONSE_CHNG		0x84
#define VAL_SESSION_KEEPALIVE			0x85

// session nack message type

#define VAL_ERROR_SES_NL_CALLEDNAME		0x80
#define VAL_ERROR_SES_NL_CALLINGNAME	0x81
#define VAL_ERROR_SES_NP_CALLEDNAME		0x82
#define VAL_ERROR_SES_RES_INSUFFICIENT	0x83
#define VAL_ERROR_SES_UNSPECIFIED		0x8F


#ifdef __cplusplus
}
#endif

#endif // _LIBNBT_MES_H_
