/* -*- tab-width: 4; -*- */
/*------------------------------------------------------------------*
 * Filename:		libnbt_mes_private.h
 *------------------------------------------------------------------*/


#ifndef _LIBNBT_MES_PRIVATE_H_
#define _LIBNBT_MES_PRIVATE_H_

#ifdef __cplusplus
extern "C" {
#endif

///////////////////////////////
// NameServiceHeader define
#ifdef WIN32
#pragma pack(push, 1)
#endif // WIN32

struct tag_stNameServiceHeader
{
	u_short	id;
	u_short	flags;
	u_short qdc;
	u_short	anc;
	u_short	nsc;
	u_short	arc;
	u_char	body[0];

#ifndef WIN32
} __attribute__((__packed__));
#else	
};
#endif // WIN32

#ifdef WIN32
#pragma pack(pop)
#endif // WIN32

typedef struct tag_stNameServiceHeader stNameServiceHeader;

// Get flags
#define G_NSH_FLAGS_R(a)	((ntohs(a)>>15)&0x1)
#define G_NSH_FLAGS_OC(a)	((ntohs(a)>>11)&0xF)
#define G_NSH_FLAGS_AA(a)	((ntohs(a)>>10)&0x1)
#define G_NSH_FLAGS_TC(a)	((ntohs(a)>>9)&0x1)
#define G_NSH_FLAGS_RD(a)	((ntohs(a)>>8)&0x1)
#define G_NSH_FLAGS_RA(a)	((ntohs(a)>>7)&0x1)
#define G_NSH_FLAGS_B(a)	((ntohs(a)>>4)&0x1)
#define G_NSH_FLAGS_RC(a)	((ntohs(a)&0xF))

// Set flags
#define S_NSH_FLAGS_R(a,b)	((a)|=htons((u_short)(((u_char)b)&0x1)<<15))
#define S_NSH_FLAGS_OC(a,b)	((a)|=htons((u_short)(((u_char)b)&0xF)<<11))
#define S_NSH_FLAGS_AA(a,b)	((a)|=htons((u_short)(((u_char)b)&0x1)<<10))
#define S_NSH_FLAGS_TC(a,b)	((a)|=htons((u_short)(((u_char)b)&0x1)<<9))
#define S_NSH_FLAGS_RD(a,b)	((a)|=htons((u_short)(((u_char)b)&0x1)<<8))
#define S_NSH_FLAGS_RA(a,b)	((a)|=htons((u_short)(((u_char)b)&0x1)<<7))
#define S_NSH_FLAGS_B(a,b)	((a)|=htons((u_short)(((u_char)b)&0x1)<<4))
#define S_NSH_FLAGS_RC(a,b)	((a)|=htons((u_short)(((u_char)b)&0xF)))


// clear
#define C_NSH_FLAGS_OC(a)	((a)&=htons((u_short)~(0xF<<11)));


///////////////////////////////
// NameServiceQuestionEntries define
#ifdef WIN32
#pragma pack(push, 1)
#endif // WIN32

struct tag_stNameServiceQuestionEntries
{
	// u_char	qn[0];
	// u_char	qs[0];
	u_short	qt;
	u_short	qc;
	u_char	next[0];

#ifndef WIN32
} __attribute__((__packed__));
#else	
};
#endif // WIN32

#ifdef WIN32
#pragma pack(pop)
#endif // WIN32

typedef struct tag_stNameServiceQuestionEntries stNameServiceQuestionEntries;


///////////////////////////////
// NameServiceARREntries define

#ifdef WIN32
#pragma pack(push, 1)
#endif // WIN32

struct tag_stNameServiceARREntries
{
	// u_char	rrn[0];
	// u_char	rrs[0];
	u_short	rrt;
	u_short	rrc;
	u_long	ttl;
	u_short	rlen;
	u_char	rdata[0];
	
#ifndef WIN32
} __attribute__((__packed__));
#else	
};
#endif // WIN32


#ifdef WIN32
#pragma pack(pop)
#endif // WIN32

typedef struct tag_stNameServiceARREntries stNameServiceARREntries;

///////////////////////////////
// NameServiceARREntries2 define
#ifdef WIN32
#pragma pack(push, 1)
#endif // WIN32

struct tag_stNameServiceARREntries2
{
	u_short	rrn; // use pointer
	u_short	rrt;
	u_short	rrc;
	u_long	ttl;
	u_short	rlen;
	u_char	rdata[0];
	
#ifndef WIN32
} __attribute__((__packed__));
#else	
};
#endif // WIN32

#ifdef WIN32
#pragma pack(pop)
#endif // WIN32

typedef struct tag_stNameServiceARREntries2 stNameServiceARREntries2;

///////////////////////////////
// NameServiceRRData define
#ifdef WIN32
#pragma pack(push, 1)
#endif // WIN32

struct tag_stNameServiceRRData
{
	u_short	flags;
	u_long	nbaddr;
	u_char	next[0];

#ifndef WIN32
} __attribute__((__packed__));
#else	
};
#endif // WIN32

#ifdef WIN32
#pragma pack(pop)
#endif // WIN32

typedef struct tag_stNameServiceRRData stNameServiceRRData;


#ifdef WIN32
#pragma pack(push, 1)
#endif // WIN32

struct tag_stNodeStatusResponseNodeNamePacket
{
	u_char	nbname[NBT_LENGTH_NETBIOSNAME];	// 16oCgŒ
	u_short	flags;
	u_char	next[0];
	
#ifndef WIN32
} __attribute__((__packed__));
#else	
};
#endif // WIN32

#ifdef WIN32
#pragma pack(pop)
#endif // WIN32

typedef struct tag_stNodeStatusResponseNodeNamePacket stNodeStatusResponseNodeNamePacket;


// Get
#define G_NSR_FLAGS_G(a)		((ntohs(a)>>15)&0x1)
#define G_NSR_FLAGS_ONT(a)		((ntohs(a)>>13)&0x3)
#define G_NSR_FLAGS_DRG(a)		((ntohs(a)>>12)&0x1)
#define G_NSR_FLAGS_CNF(a)		((ntohs(a)>>11)&0x1)
#define G_NSR_FLAGS_ACT(a)		((ntohs(a)>>10)&0x1)
#define G_NSR_FLAGS_PRM(a)		((ntohs(a)>>9)&0x1)
#define G_NSR_FLAGS_RESERVED(a)	((ntohs(a))&0x1FF)

// Set
#define S_NSR_FLAGS_G(a,b)			((a)|=htons((((u_char)b)&0x1)<<15))
#define S_NSR_FLAGS_ONT(a,b)		((a)|=htons((((u_char)b)&0x3)<<13))
#define S_NSR_FLAGS_DRG(a,b)		((a)|=htons((((u_char)b)&0x1)<<12))
#define S_NSR_FLAGS_CNF(a,b)		((a)|=htons((((u_char)b)&0x1)<<11))
#define S_NSR_FLAGS_ACT(a,b)		((a)|=htons((((u_char)b)&0x1)<<10))
#define S_NSR_FLAGS_PRM(a,b)		((a)|=htons((((u_char)b)&0x1)<<9))
#define S_NSR_FLAGS_RESERVED(a,b)	((a)|=htons(((u_char)b)&0x1FF))


// typedef stNodeStatusResponseNodeStatus stNodeStatusResponseNodeStatusPacket;

///////////////////////////////
// stDatagramService Define
#ifdef WIN32
#pragma pack(push, 1)
#endif // WIN32

struct tag_stDatagramServiceFormat
{
	u_char	msgtype;
	u_char	flags;
	u_short	id;
	u_long	ip;
	u_short	port;
	union{
		// direct_unique, direct_group, broadcast datagram
		struct tag_form1{
			u_short	len;
			u_short	offset;

			//u_char	srcname[0];
			//u_char	srcscopeid[0];

			//u_char	dstname[0];
			//u_char	dstscopeid[0];
			u_char	body[0];
		} form1;

		// datagram error packet
		struct tag_form2{
			u_char	ecode;
		} form2;

		// datagram query request, datagram positive and negative response
		struct tag_form3{
			//u_char	dstname[0];
			//u_char	scopeid[0];
			u_char	body[0];
		} form3;
	} u;
#define DSF1_len		u.form1.len
#define DSF1_offset		u.form1.offset
#define DSF1_srcname	u.form1.body
#define DSF1_srcscopeid	u.form1.body
#define DSF1_dstname	u.form1.body
#define DSF1_dstscopeid	u.form1.body
#define DSF1_body		u.form1.body
#define DSF2_ecode		u.form2.ecode
#define DSF3_dstname	u.form3.body
#define DSF3_scopeid	u.form3.body

#ifndef WIN32
} __attribute__((__packed__));
#else	
};
#endif // WIN32

#ifdef WIN32
#pragma pack(pop)
#endif // WIN32

typedef struct tag_stDatagramServiceFormat stDatagramServiceFormat;


// FLAGS
#define G_DSF_FLAGS_SNT(a)		(((a)>>2)&0x3)
#define G_DSF_FLAGS_F(a)		(((a)>>1)&0x1)
#define G_DSF_FLAGS_M(a)		((a)&0x1)

#define S_DSF_FLAGS_SNT(a,b)	((a)|=(((u_char)b)&0x3)<<2)
#define S_DSF_FLAGS_F(a,b)		((a)|=(((u_char)b)&0x1)<<1)
#define S_DSF_FLAGS_M(a,b)		((a)|=(((u_char)b)&0x1))


#ifdef __cplusplus
}
#endif

#endif // _LIBNBT_MES_PRIVATE_H_
