/* -*- tab-width: 4; -*- */
/*------------------------------------------------------------------*
 * Filename:		libnbt_ns.h
 *------------------------------------------------------------------*/

#ifndef _LIBNBT_NS_H_
#define _LIBNBT_NS_H_

#ifdef __cplusplus
extern "C" {
#endif

extern int nbt_addname(int s, const NBTNamePack* np, unsigned long* refresh, unsigned char* rcode,
					   NBTForceSettingInfo* fcinfo);
extern int nbt_addname_multihomed(int s, const NBTNamePack* np, unsigned long* refresh, unsigned char* rcode,
								  NBTForceSettingInfo* fcinfo);

extern int nbt_findname(int s, const NBTNamePack* np, NBTAddrPack* ap, int num, int* findnum, NBTForceSettingInfo* fcinfo);
extern int nbt_deletename(int s, const NBTNamePack* np, NBTForceSettingInfo* fcinfo);

/* low level function */
extern int nbt_addname_unicast(int s, const NBTNamePack* np, unsigned long winsnaddr,
							   unsigned long* refresh, unsigned char* rcode,
							   NBTForceSettingInfo* fcinfo);
extern int nbt_addname_broadcast(int s, const NBTNamePack* np, unsigned char* rcode,
								 NBTForceSettingInfo* fcinfo);

extern int nbt_addname_multihomed_unicast(int s, const NBTNamePack* np, unsigned long winsnaddr,
										  unsigned long* refresh, unsigned char* rcode, NBTForceSettingInfo* fcinfo);

extern int nbt_findname_unicast(int s, const NBTNamePack* np, unsigned long winsnaddr, NBTAddrPack* ap, int num,
								int* findnum, NBTForceSettingInfo* fcinfo);
extern int nbt_findname_broadcast(int s, const NBTNamePack* np, NBTAddrPack* ap, int num,
								  int* findnum, NBTForceSettingInfo* fcinfo);

extern int nbt_deletename_unicast(int s, const NBTNamePack* np, unsigned long winsnaddr, NBTForceSettingInfo* fcinfo);
extern int nbt_deletename_broadcast(int s, const NBTNamePack* np, NBTForceSettingInfo* fcinfo);

extern int nbt_updatename_unicast(int s, const NBTNamePack* np, unsigned long winsnaddr, NBTForceSettingInfo* fcinfo);

extern int nbt_getnodestatus(int s, const NBTNamePack* np,
					NBTNodeName* nodename, int nodename_num, int* get_nodename_num,
					NBTNodeStatistics* statistics,
					NBTForceSettingInfo* fcinfo);
					
#ifdef __cplusplus
}
#endif

#endif // _LIBNBT_NS_H_
