/* -*- tab-width: 4; -*- */
/*------------------------------------------------------------------*
 * Filename:		libnbt_private.h
 *------------------------------------------------------------------*/
 

#ifndef _LIBNBT_LOCAL_H_
#define _LIBNBT_LOCAL_H_

#ifdef __cplusplus
extern "C" {
#endif

// STATE
#define STATE_OPENED		0
#define STATE_LISTENED		1
#define STATE_ACCEPTED_TCP	2
#define STATE_CONNECTED_TCP	3
#define STATE_CONNECTED		4
#define STATE_DISCONNECTED	5



typedef struct nbtctbl_tag
{
	int serviceType;					/* T[rX^CvBȉ̂ꂩ̒l
											NBT_STYPE_NAME		0
											NBT_STYPE_SESSION	1
											NBT_STYPE_DATAGRAM	2
										*/
										
	int messageType;					/* ݎMobt@̐擪ɂAbZ[W̃bZ[W^Cv
											NBT_MTYPE_SES_MES		100
											NBT_MTYPE_SES_REQ		101
											NBT_MTYPE_SES_RES_ACK	102
											NBT_MTYPE_SES_RES_NACK	103
											NBT_MTYPE_SES_RES_CHNG	104
											NBT_MTYPE_SES_KPALIV	105
											NBT_MTYPE_SES_DISCON	1000
										*/
										
	int isUsed;							/* e[ugp
											0: unused, 1: used
										*/
										
	int fd;								/* \PbgfBXNv^ */

	unsigned long	srcnaddr;			/* Src IP-Address (n-byte order) */
	unsigned long	bcnaddr;			/* Broadcast IP-Address(n-byte order)(default: -1) */
	unsigned long	winsnaddr;			/* WINS Server Address(n-byte order) */

	int state;							/* ԁBȉ̂ꂩB
											STATE_OPENED			0
											STATE_LISTENED			1
											STATE_ACCEPTED_TCP		2
											STATE_CONNECTED_TCP		3
											STATE_CONNECTED			4
											STATE_DISCONNECTED		5
										*/
										
	unsigned long messageTotalLen;		/* 1-message Data length */
	unsigned long readLen;				/* readLength */
	
	int isReadHeader; 					/* wb_ǂݍݍς݂
											0: not read header
											1: read header
										*/
										
	int isPacketLast;					/* 1pPbg̍Ōɂ邩H
											0: r
											1: Ō
										*/
	
	int cfd;							/* TCPxacceptɓV\PbgfBXNv^ێ */
	unsigned long cnaddr;				/* client addr(template) */
	unsigned short	tid;				/* TransactionID. */

	char*	scopeid;					/* ScopeID */
	
} NBTCTBL;


typedef struct tag_stGlobalSetting
{
	u_long			winsnaddr;						// NBNS(n-byte order)
	char			scopeid[NBT_LENGTH_SCOPEID];	// scopeid
	unsigned char	ont;							// Owner Node Type

} stGlobalSetting;




#ifdef __cplusplus
}
#endif


#endif // _LIBNBT_LOCAL_H_
