/* -*- tab-width: 4; -*- */
/*------------------------------------------------------------------*
 * Filename:		libnbt_ss.c
 *------------------------------------------------------------------*/

#ifndef _LIBNBT_SS_H_
#define _LIBNBT_SS_H_

#ifdef __cplusplus
extern "C" {
#endif

typedef int (*AcceptProc)(const NBTNamePack* , const NBTNamePack* );

extern int nbt_listen(int s, int backlog);
extern int nbt_accept(int s, NBTNamePack* rmt, AcceptProc proc);
extern int nbt_connect(int s, const NBTNamePack* rmt, const NBTNamePack* local,
					   unsigned long timeout_msec);
extern int nbt_send(int s, const void* msg, int len, unsigned int flags);
extern int nbt_send_ack(int s);
extern int nbt_send_nack(int s, int errortype);
extern int nbt_send_change(int s, unsigned long naddr, unsigned short nport);
extern int nbt_send_keepalive(int s);
extern int nbt_recv(int s, void* buf, int len, unsigned int flags, unsigned int flags2);
extern int nbt_look(int s, int keepLastState);

#ifdef __cplusplus
}
#endif

#endif // _LIBNBT_SS_H_
