/* -*- tab-width: 4; -*- */
/*------------------------------------------------------------------*
 * Filename:		libnbt_util.h
 *------------------------------------------------------------------*/

#ifndef _LIBNBT_UTIL_H_
#define _LIBNBT_UTIL_H_

#ifdef __cplusplus
extern "C" {
#endif

#define IGNORE_PACKET_BUFSIZE	1024 /* ignore_packetŎgpobt@TCY */


#define CHAR_ASCII			0		/* ascii code */
#define CHAR_KANA			1		/* pJi */
#define CHAR_SHIFT_JIS_0	2		/* shift jis(OoCg) */
#define CHAR_SHIFT_JIS_1	3		/* shift jis(oCg) */


extern void nbt_strupper(char *s);
extern void nbt_strlower(char *s);

extern int nbt_padname(const char* s, u_char* d, int len, unsigned char c, unsigned char suffix);
extern int nbt_devidename(char* nm, u_char* suffix, const u_char* snm);
extern int nbt_encscopeid(unsigned char* out, int outsize, const char* in);
extern int nbt_decscopeid(char* out, int outsize, const unsigned char* in);
extern int nbt_enc2nd(u_char* dst, int len, const u_char* nm, const u_char* scope);
extern int nbt_dec2nd(u_char* nm, u_char* scope, int len, const u_char* nbtnm, const u_char* top, int* readsize,
				  u_char* uselabel, int* labelindex);


extern int nbt_readable(int fd, long msec, int interruptd);
extern int nbt_readable_checkalive(int fd, long msec);
extern int nbt_writable(int fd, long msec, int interruptd);
extern int nbt_in_sendto(int fd, const void* msg, size_t len, int flags, u_long dstnaddr, u_short dstnport,
						long timeout, int interruptd);
extern int nbt_in_recvfrom(int fd, void* buf, size_t len, int flags, u_long* rnaddr, u_short* rnport,
						long timeout, int interruptd);
extern int nbt_in_recv(int fd, void* buf, size_t len, int flags);
extern int nbt_ignore_packet(int sd, int interruptd);
extern unsigned short nbt_getnport(int fd);
extern int nbt_analyze_char(const char* str, int index);
extern int nbt_checkvalidscopeid(const char* scopeid);

#ifdef __cplusplus
}
#endif

#endif // _LIBNBT_UTIL_H_

