#ifdef GWIPC_USE_SOCKET
#include <pthread.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/stat.h>


//////////////////////////////////////////////////////////////////////////////
// define`
#define BUFF_SIZE		(64)		// obt@TCY
						//	^uAj[TCY	

//////////////////////////////////////////////////////////////////////////////
// smbcd ł̊֐
#ifdef SMBCD_USE
#define NcsGetXXXConf   smbcd_NcsGetXXXConf
#define get_tag_ul      smbcd_get_tag_ul
#define get_tag_str     smbcd_get_tag_str
#define search_tag      smbcd_search_tag
#define read_tag        smbcd_read_tag
#define skip_term       smbcd_skip_term
#define read_string     smbcd_read_string
#define read_char       smbcd_read_char
#define check_term      smbcd_check_term
#endif

//////////////////////////////////////////////////////////////////////////////
// prototype錾
int NcsGetXXXConf( char* file, char* tag, char* menu, char* str, int str_max );
int get_tag_ul( int fd, char* tag, char* menu, u_long* ul );
int get_tag_str( int fd, char* tag, char *menu, char* str, int str_max );
int search_tag( int fd, char* tag, char* menu, char* str, int str_max );
int read_tag( int fd, char* str, int str_max );
int skip_term( int fd, char* term_tbl );
int read_string( int fd, char* str, int str_max, char* term_tbl );
int read_char( int fd, char *c );
int check_term( char c, char* term_tbl );


//////////////////////////////////////////////////////////////////////////////
// Oϐ
char	p_char = 0;			// read_char  ǂݍ񂾒l

char	term_tbl[] 	= { 0x0d, 0x0a, 0 };		// s[
char	tag_term_tbl[] 	= { 0x0d, 0x0a, ']', 0 };	// ^u[s[
char	menu_term_tbl[] = { 0x0d, 0x0a, '=', 0x20, 0x09, 0 };	// j[[s[
char	eql_term_tbl[] 	= { '=', 0x20, 0x09, 0 };	// Xy[XA^uA=
char	sp_term_tbl[] 	= { 0x20, 0x09, 0 };		// Xy[XA^u


//////////////////////////////////////////////////////////////////////////////
// ֐
// 
//////////////////////////////////////////////////////////////////////////////
// SMTP֘Ap[^ /udom/smtp.conf ɏoB
// 	FFSgp\ȃJ[lK{
//	return 0...OK, -1...error
int
NcsGetXXXConf( char* file, char* tag, char* menu, char* str, int str_max )
{
	int	fd;
	int	ret;

	// open
	if( (fd = open(file, (O_RDONLY) )) < 0 ){
		return -1;
	}
	
	// search tag parameter
	ret = search_tag( fd, tag, menu, str, str_max ); 

	// close
	close( fd );

#ifdef	_DEBUG_
#ifdef	_DEBUG_NCSSMTP_TEST_
#else
printf( "[%s][%s][%s] %d\n", tag, menu, str, ret  );
#endif
#endif

	return( ret );	// 0...OK, -1...error
}

//////////////////////////////////////////////////////////////////////////////
// tag  menu 當oB
// 	tag w肳ȂꍇAj[ł̂݌B
//	return 0...OK, -1...error
int
get_tag_str( int fd, char* tag, char *menu, char* str, int str_max )
{
	int	ret;
	ret = search_tag( fd, tag, menu, str, str_max );
	return( ret );
}

//////////////////////////////////////////////////////////////////////////////
// unsigned long  tag  menu 琔loB
// 	tag w肳ȂꍇAj[ł̂݌B
//	return 0...OK, -1...error
int
get_tag_ul( int fd, char* tag, char* menu, u_long* ul )
{
	int	ret;
	char	buff[BUFF_SIZE];

	ret = search_tag( fd, tag, menu, buff, sizeof(buff) );
	*ul = strtoul( buff, (char**)NULL, 0 );
	return( ret );
}

//////////////////////////////////////////////////////////////////////////////
// tag  menu  ̃p[^ search B
// search ʂ str ɃZbgB
// 	tag w肳ȂꍇAj[ł̂݌B
//	return 0...OK, -1...error
int
search_tag( int fd, char* tag, char* menu, char* str, int str_max )
{
	char	c;
	char	prev;
	char	tag_buff[BUFF_SIZE];
	char	menu_buff[BUFF_SIZE];
	int	ret;

	lseek( fd, 0, SEEK_SET );	// t@C̐擪

	if( tag == 0 || *tag == 0 )	// tag w肳ĂȂꍇAtag  NULL ƂĈB
		tag = tag_buff;

	str[0] = 0;			// "" Zbg
	prev = 0;
	while( 1 ){
		if( (ret = read_char( fd, &c )) <= 0 ){
			return( -1 );
		}
		if( check_term( prev, term_tbl ) == 1 ){
			// ^Ǒ '[' sɂ̂T ']' ܂œǂݍ
			if( c == '[' ){
				// ^Oǂݍ
				strncpy( tag_buff, "", BUFF_SIZE );
				ret = read_string( fd, tag_buff, BUFF_SIZE, tag_term_tbl );
				if( ret <= 0 )
					return( -1 );

				// ']' ܂œǂݍł̂ŁA']' ȍ~̓XLbv
				if( check_term( p_char, term_tbl ) != 1 ){	// I[ł͂Ȃ	
					ret = skip_term( fd, term_tbl );	// ǂݎ̂
					if( ret <= 0 )
						return( -1 );
				}
			}
			// Rgs ('#'Ŏn܂sj̓ǂݔ΂
			else if( c == '#' ){
				// ǂݎ̂
				if( check_term( p_char, term_tbl ) != 1 ){	// I[ł͂Ȃ	
					ret = skip_term( fd, term_tbl );	// ǂݎ̂
					if( ret <= 0 )
						return( -1 );
				}
			}
			// j[š
			else if( check_term( c, term_tbl ) == 0 ){
				// 擪Xy[XA^ȕꍇ͓ǂݔ΂B
				while( check_term( p_char, sp_term_tbl ) == 1 ){	// ǂ񂾕`FbN
					if( (ret = read_char( fd, &c )) <= 0 ){
						return( -1 );
					}
				}

				// j[ǂݍ
				// 1ǂݏoĂ̂ŁAOăZbgB
				menu_buff[0] = p_char;		// O̕
				ret = read_string( fd, menu_buff+1, BUFF_SIZE-1, menu_term_tbl );
				if( ret <= 0 )
					return( -1 );

				// Xy[XA^uA=A͓ǂݔ΂
				while( check_term( p_char, eql_term_tbl ) == 1 ){	// ǂ񂾕`FbN
					if( (ret = read_char( fd, &c )) <= 0 ){
						return( -1 );
					}
				}

				// ^Oƃj[v邩ǂ`FbN
				// ^ȌꍇAj[v邩ǂ`FbNB
				// vꍇ͍s܂œǂݍ
				// vȂꍇ͍s܂œǂݎ̂Ă
				if( (strncmp( tag_buff, tag, BUFF_SIZE ) == 0) && (strncmp( menu_buff, menu, BUFF_SIZE ) == 0) ){
					if( check_term( p_char, term_tbl ) == 1 ){	// łɏI[	
						str[0] = 0;				// "" Zbg
					} 
					else {
						str[0] = p_char;	// O̕
						ret = read_string( fd, str+1, str_max-1, term_tbl );	// I[܂œǂ
						if( ret <= 0 )
							return( -1 );
					}
					return( 0 );		// FIND
				}
				else {
					// ǂݎ̂
					if( check_term( p_char, term_tbl ) != 1 ){	// I[ł͂Ȃ	
						ret = skip_term( fd, term_tbl );	// ǂݎ̂
						if( ret <= 0 )
							return( -1 );
					}
				}
			}
		} 
		prev = p_char;
	}
	return( -1 );		// NOT FIND
}

//////////////////////////////////////////////////////////////////////////////
// term_tbl ܂ skip (read) B
// 
int
skip_term( int fd, char* term_tbl )
{
	char	c;
	int	ret = 0;

	while( 1 ){
		ret = read_char( fd, &c );
		if( ret <= 0 )
			break;
		if( check_term( c, term_tbl ) == 1 )	// check terminate 
			break;
	}
	return( ret );		// OK string, EOF 0, ERR -1
}

//////////////////////////////////////////////////////////////////////////////
// string  term_tbl ܂ read B
// 
int
read_string( int fd, char* str, int str_max, char* term_tbl )
{
	char	c;
	int	ret = 0;

	while( str_max > 1 ){
		ret = read_char( fd, &c );
		if( ret <= 0 )
			c = 0;	// set terminate
		if( check_term( c, term_tbl ) == 1 ){	// check terminate 
			str_max = 0;
			c = 0;
		}
		if( c != 0 ){
			*str = c;
			str++;
		}
		str_max--;
	}
	*str = 0;

	return( ret );		// OK string size, EOF 0, ERR -1
}

//////////////////////////////////////////////////////////////////////////////
// terminate  check B
// 
int
check_term( char c, char* term_tbl )
{
	int	i;

	if( c == 0 ){
		return( 1 );			// terminate
	}
	for( i=0; *term_tbl; term_tbl++, i++ ){
		if( c == *term_tbl ){
			return( 1 );		// terminate
		}
	}
	return( 0 );				// not terminate
}

//////////////////////////////////////////////////////////////////////////////
// char  read B
// 
int
read_char( int fd, char *c )
{
	int		ret;

	ret = read( fd, c, sizeof(*c) ) ;
	p_char = *c;
	return( ret );		// OK string, EOF 0, ERR -1
}

#ifdef	_DEBUG_
#ifdef	_DEBUG_NCSSMTP_TEST_
#else
//////////////////////////////////////////////////////////////////////////////
// _DEBUG_
// main
//
main()
{
	char	buff[128];
	int	fd;
	u_long	ul;
printf("_DEBUG_\n");
	NcsGetXXXConf( SMTP_CONF_PATH_NAME, 0, "servername", buff, sizeof(buff) );
	NcsGetXXXConf( SMTP_CONF_PATH_NAME, "", "servername", buff, sizeof(buff) );
	NcsGetXXXConf( SMTP_CONF_PATH_NAME, "smtp", "servername", buff, sizeof(buff) );
	NcsGetXXXConf( SMTP_CONF_PATH_NAME, "smtp", "port", buff, sizeof(buff) );
	NcsGetXXXConf( SMTP_CONF_PATH_NAME, "ipif", "ip1", buff, sizeof(buff) );
	NcsGetXXXConf( SMTP_CONF_PATH_NAME, "ipif", "type2", buff, sizeof(buff) );
	NcsGetXXXConf( SMTP_CONF_PATH_NAME, "ipif", "ip2", buff, sizeof(buff) );
	NcsGetXXXConf( SMTP_CONF_PATH_NAME, "ipif", "ip3", buff, sizeof(buff) );
	fd = open( SMTP_CONF_PATH_NAME, (O_RDONLY) );
	get_tag_str( fd, "ipif", "ip3", buff, sizeof(buff) );	printf( "ip3" "buff=%s\n", buff );
	get_tag_ul ( fd, "ipif", "ip3", &ul );			printf( "ip3" "ul=0x%x\n", ul );
								printf( "ip3" "ul=%s\n", inet_ntoa(ul) );
	close( fd );
printf("\n");
}

//////////////////////////////////////////////////////////////////////////////
#endif	_DEBUG_NCSSMTP_TEST_
#endif	_DEBUG_

/* ----- end of file ----- */

